{ This library is free software; you can redistribute it and/or modify it
  under the terms of the GNU Library General Public License as published by
  the Free Software Foundation; either version 2 of the License, or (at your
  option) any later version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public License
  for more details.

  You should have received a copy of the GNU Library General Public License
  along with this library; if not, write to the Free Software Foundation,
  Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

  ---------------------------------------------------------------------------

    Author : Luc DAVID Email: luckylazarus@free.fr
    Copyright (C) 2007
    Last update : 15/01/2007

  --------------------------------------------------------------------------- }

unit SqlitePassChooseDatasetDialog;
{$IFDEF FPC}
 {$mode DELPHI}
{$ENDIF}

interface

uses
 {$IFDEF FPC}
  LResources,
 {$ENDIF}
 {$IFDEF WIN32}
  Windows,
 {$ENDIF}
  Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, DB, ComCtrls, SqlitePassDbo;

type

  { TSqlitePassChooseDatasetDialog }

  TSqlitePassChooseDatasetDialog = class(TForm)
    PanelBottom: TPanel;
    BtOk: TButton;
    BtCancel: TButton;
    PanelTop: TPanel;
    LabelAvailableDatasets: TLabel;
    Tv: TTreeView;
    procedure TvDblClick(Sender: TObject);
   Public
   constructor Create(AOwner: TComponent; Dataset: TSqlitePassDataset); reintroduce;
  end;

var
  SqlitePassChooseDatasetDlg: TSqlitePassChooseDatasetDialog;

implementation

{$IFNDEF FPC}
 {$R *.DFM}
{$ENDIF}

constructor TSqlitePassChooseDatasetDialog.Create(AOwner: TComponent;
  Dataset: TSqlitePassDataset);
var
i: integer;
DatabaseNode, TablesNode, QueriesNode, SystemTablesNode: TTreeNode;
Db: TSqlitePassDatabase;
begin
inherited Create(AOwner);
if Dataset = nil then exit;
Db := Dataset.Database;
if Db = nil then exit;

Tv.Items.Clear;
DatabaseNode:= Tv.Items.Add(nil,'Database');
TablesNode  := Tv.Items.AddChild(DatabaseNode,'Tables');
QueriesNode := Tv.Items.AddChild(DatabaseNode,'Queries');
SystemTablesNode := Tv.Items.AddChild(DatabaseNode,'System Tables');
Db.RefreshDefinitions;

for i:= 0 to Pred(Db.TableDefs.Count)
    do if Not Db.IsSystemTable(Db.TableDefs[i].TableFullName)
       then Tv.Items.AddChild(TablesNode,Db.TableDefs[i].TableFullName)
       else Tv.Items.AddChild(SystemTablesNode,Db.TableDefs[i].TableFullName);

for i:= 0 to Pred(Db.QueryDefs.Count)
   do Tv.Items.AddChild(QueriesNode,Db.QueryDefs[i].QueryName);

Tv.FullExpand;
end;

procedure TSqlitePassChooseDatasetDialog.TvDblClick(Sender: TObject);
begin
ModalResult := mrOk;
end;

initialization
 {$IFDEF FPC}
  {$I SqlitePassSortByDialog.lrs}
 {$ENDIF}
end.